Loading...
Searching...
No Matches
gtsam::CustomFactor Class Reference
Inheritance diagram for gtsam::CustomFactor:

## Public Member Functions

| CustomFactor ()=default
| Default Constructor for I/O.
| CustomFactor (const SharedNoiseModel &noiseModel, const KeyVector &keys, const CustomErrorFunction &errorFunction)
| Constructor.
Vector | unwhitenedError (const Values &x, boost::optional< std::vector< Matrix > & > H=boost::none) const override
| Calls the errorFunction closure, which is a std::function object One can check if a derivative is needed in the errorFunction by checking the length of Jacobian array.
void | print (const std::string &s, const KeyFormatter &keyFormatter=DefaultKeyFormatter) const override
| print
bool | sendable () const override
| Mark not sendable.
Public Member Functions inherited from gtsam::NoiseModelFactor
| NoiseModelFactor ()
| Default constructor for I/O only.
| ~NoiseModelFactor () override
| Destructor.
template<typename CONTAINER>
| NoiseModelFactor (const SharedNoiseModel &noiseModel, const CONTAINER &keys)
| Constructor.
void | print (const std::string &s="", const KeyFormatter &keyFormatter=DefaultKeyFormatter) const override
| Print.
bool | equals (const NonlinearFactor &f, double tol=1e-9) const override
| Check if two factors are equal.
size_t | dim () const override
| get the dimension of the factor (number of rows on linearization)
const SharedNoiseModel & | noiseModel () const
| access to the noise model
Vector | whitenedError (const Values &c) const
| Vector of errors, whitened This is the raw error, i.e., i.e.
Vector | unweightedWhitenedError (const Values &c) const
| Vector of errors, whitened, but unweighted by any loss function.
double | weight (const Values &c) const
| Compute the effective weight of the factor from the noise model.
double | error (const Values &c) const override
| Calculate the error of the factor.
boost::shared_ptr< GaussianFactor > | linearize (const Values &x) const override
| Linearize a non-linearFactorN to get a GaussianFactor, \( Ax-b \approx h(x+\delta x)-z = h(x) + A \delta x - z \) Hence \( b = z - h(x) = - \mathtt{error\_vector}(x) \).
shared_ptr | cloneWithNewNoiseModel (const SharedNoiseModel newNoise) const
| Creates a shared_ptr clone of the factor with a new noise model.
| NonlinearFactor ()
| Default constructor for I/O only.
template<typename CONTAINER>
| NonlinearFactor (const CONTAINER &keys)
| Constructor from a collection of the keys involved in this factor.
void | print (const std::string &s="", const KeyFormatter &keyFormatter=DefaultKeyFormatter) const override
| print
virtual | ~NonlinearFactor ()
| Destructor.
double | error (const HybridValues &c) const override
| All factor types need to implement an error function.
virtual bool | active (const Values &) const
| Checks whether a factor should be used based on a set of values.
virtual shared_ptr | clone () const
| Creates a shared_ptr clone of the factor - needs to be specialized to allow for subclasses.
virtual shared_ptr | rekey (const std::map< Key, Key > &rekey_mapping) const
| Creates a shared_ptr clone of the factor with different keys using a map from old->new keys.
virtual shared_ptr | rekey (const KeyVector &new_keys) const
| Clones a factor and fully replaces its keys.
Public Member Functions inherited from gtsam::Factor
virtual | ~Factor ()=default
| Default destructor.
bool | empty () const
| Whether the factor is empty (involves zero variables).
Key | front () const
| First key.
Key | back () const
| Last key.
const_iterator | find (Key key) const
| find
const KeyVector & | keys () const
| Access the factor's involved variable keys.
const_iterator | begin () const
| Iterator at beginning of involved variable keys.
const_iterator | end () const
| Iterator at end of involved variable keys.
size_t | size () const
virtual void | printKeys (const std::string &s="Factor", const KeyFormatter &formatter=DefaultKeyFormatter) const
| print only keys
bool | equals (const This &other, double tol=1e-9) const
| check equality
KeyVector & | keys ()
iterator | begin ()
| Iterator at beginning of involved variable keys.
iterator | end ()
| Iterator at end of involved variable keys.

## Protected Types

using | Base = NoiseModelFactor
using | This = CustomFactor
Protected Types inherited from gtsam::NoiseModelFactor
typedef NonlinearFactor | Base
typedef NoiseModelFactor | This
Protected Types inherited from gtsam::NonlinearFactor
typedef Factor | Base
typedef NonlinearFactor | This

## Protected Attributes

CustomErrorFunction | error_function_
Protected Attributes inherited from gtsam::NoiseModelFactor
SharedNoiseModel | noiseModel_
Protected Attributes inherited from gtsam::Factor
KeyVector | keys_
| The keys involved in this factor.

## Friends

class | boost::serialization::access
| Serialization function.

## Additional Inherited Members

Public Types inherited from gtsam::NoiseModelFactor
typedef boost::shared_ptr< This > | shared_ptr
| Noise model.
Public Types inherited from gtsam::NonlinearFactor
typedef boost::shared_ptr< This > | shared_ptr
Public Types inherited from gtsam::Factor
typedef KeyVector::iterator | iterator
| Iterator over keys.
typedef KeyVector::const_iterator | const_iterator
| Const iterator over keys.
Protected Member Functions inherited from gtsam::NoiseModelFactor
| NoiseModelFactor (const SharedNoiseModel &noiseModel)
| Constructor - only for subclasses, as this does not set keys.
| Factor ()
| Default constructor for I/O.
template<typename CONTAINER>
| Factor (const CONTAINER &keys)
| Construct factor from container of keys.
template<typename ITERATOR>
| Factor (ITERATOR first, ITERATOR last)
| Construct factor from iterator keys.
template<typename CONTAINER>
static Factor | FromKeys (const CONTAINER &keys)
| Construct factor from container of keys.
template<typename ITERATOR>
static Factor | FromIterators (ITERATOR first, ITERATOR last)
| Construct factor from iterator keys.

## Constructor & Destructor Documentation

## CustomFactor()

gtsam::CustomFactor::CustomFactor | ( | const SharedNoiseModel & | noiseModel,
|  | const KeyVector & | keys,
|  | const CustomErrorFunction & | errorFunction )

inline

Constructor.

Parameters

  noiseModel | shared pointer to noise model
  keys | keys of the variables
  errorFunction | the error functional

## Member Function Documentation

## print()

void gtsam::CustomFactor::print | ( | const std::string & | s,
|  | const KeyFormatter & | keyFormatter = DefaultKeyFormatter ) const

override virtual

print

Reimplemented from gtsam::Factor.

## sendable()

bool gtsam::CustomFactor::sendable | ( |  | ) | const

inline override virtual

Mark not sendable.

Reimplemented from gtsam::NonlinearFactor.

## unwhitenedError()

Vector gtsam::CustomFactor::unwhitenedError | ( | const Values & | x,
|  | boost::optional< std::vector< Matrix > & > | H = boost::none ) const

override virtual

Calls the errorFunction closure, which is a std::function object One can check if a derivative is needed in the errorFunction by checking the length of Jacobian array.

Implements gtsam::NoiseModelFactor.

The documentation for this class was generated from the following files:

- /build/gtsam-Xg031d/gtsam-4.2.0+dfsg/gtsam/nonlinear/CustomFactor.h
- /build/gtsam-Xg031d/gtsam-4.2.0+dfsg/gtsam/nonlinear/CustomFactor.cpp